# Generated by Django 3.2.19 on 2023-07-03 20:12

import datetime
from django.conf import settings
import django.core.validators
from django.db import migrations, models
import django.utils.timezone
import enumfields.fields
import hunts.models
import hunts.runtimes
import uuid


class Migration(migrations.Migration):

    replaces = [('hunts', '0001_squashed_0017_auto_20190209_1436'), ('hunts', '0002_auto_20190305_0948'), ('hunts', '0003_auto_20190307_0914'), ('hunts', '0004_puzzle_url_id'), ('hunts', '0005_auto_20190811_1507'), ('hunts', '0006_auto_20200405_2052'), ('hunts', '0007_auto_20201117_2202'), ('hunts', '0008_auto_20210425_1632'), ('hunts', '0009_remove_teampuzzledata_start_time'), ('hunts', '0008_auto_20210702_1258'), ('hunts', '0010_merge_20210706_2134'), ('hunts', '0011_auto_20210723_0003'), ('hunts', '0012_auto_20210825_2149'), ('hunts', '0013_auto_20210916_2313'), ('hunts', '0014_auto_20210924_1123'), ('hunts', '0015_linear_episode_start_dates'), ('hunts', '0016_remove_announcement_event'), ('hunts', '0017_alter_headstart_options'), ('hunts', '0018_auto_20220127_2354'), ('hunts', '0019_auto_20220127_2354'), ('hunts', '0020_auto_20220127_2354'), ('hunts', '0021_announcement_notify'), ('hunts', '0022_auto_20220417_2037'), ('hunts', '0023_auto_20220919_1847'), ('hunts', '0024_auto_20221002_2318'), ('hunts', '0025_hint_obsoleted_by'), ('hunts', '0025_episode_no_stats'), ('hunts', '0026_merge_0025_episode_no_stats_0025_hint_obsoleted_by'), ('hunts', '0027_auto_20230501_1720'), ('hunts', '0027_auto_20230319_0004'), ('hunts', '0028_merge_0027_auto_20230319_0004_0027_auto_20230501_1720'), ('hunts', '0029_alter_episode_first_finishers_min_headstart'), ('hunts', '0030_auto_20230701_1615'), ('hunts', '0031_alter_teampuzzleprogress_start_time'), ('hunts', '0030_auto_20230701_1654'), ('hunts', '0032_merge_20230703_2109')]

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('events', '0001_initial'),
        ('accounts', '0001_initial'),
        ('teams', '0001_squashed_0009_auto_20221112_2303'),
    ]

    operations = [
        migrations.CreateModel(
            name='Episode',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=255)),
                ('flavour', models.TextField(blank=True, help_text='Optional story or thematic preamble, displayed alongside the list of puzzles')),
                ('start_date', models.DateTimeField(help_text='Before this point, the episode is invisible and puzzles are unavailable. The actual time is affected by headstarts. Puzzles may also have their own start date which must also be passed.')),
                ('parallel', models.BooleanField(default=False, help_text='Allow players to answer riddles in this episode in any order they like')),
                ('event', models.ForeignKey(on_delete=django.db.models.deletion.DO_NOTHING, to='events.event')),
                ('headstart_from', models.ManyToManyField(blank=True, help_text='Episodes which should grant a headstart for this episode', to='hunts.Episode')),
                ('first_finishers_headstart', models.IntegerField(default=0, help_text='The first this many teams will receive a headstart for finishing this episode, applied to any episodes which include this one in "headstarts from".', validators=[django.core.validators.MinValueValidator(0)])),
                ('first_finishers_min_headstart', models.DurationField(default=datetime.timedelta(0), help_text='The team to finish this episode in position &lt;first finishers headstart&gt; will receive this much headstart', validators=[django.core.validators.MinValueValidator(datetime.timedelta(0))])),
                ('first_finishers_max_headstart', models.DurationField(default=datetime.timedelta(0), help_text='The first team to finish this episode will receive this much headstart', validators=[django.core.validators.MinValueValidator(datetime.timedelta(0))])),
                ('cooldown_behaviour', models.CharField(choices=[('ConstantDelay', 'Constant Delay'), ('TeamWideDelay', 'Simple Team Delay'), ('ExponentialRampConstantDecay', 'Exponential-Constant')], default='ConstantDelay', max_length=255, verbose_name='Guess Cooldown Behaviour')),
                ('cooldown_parameters', models.JSONField(blank=True, default=dict)),
                ('winning', models.BooleanField(default=False, help_text='Whether this episode must be won in order to win the event')),
                ('no_stats', models.BooleanField(default=False, help_text='Whether this episode should be excluded from public facing stats pages', verbose_name='Excluded from public stats')),
            ],
            options={
                'unique_together': {('event', 'start_date')},
                'ordering': ('start_date',),
            },
        ),
        migrations.CreateModel(
            name='Puzzle',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('episode', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to='hunts.episode')),
                ('order', models.PositiveIntegerField(db_index=True, editable=False, verbose_name='order')),
                ('title', models.CharField(max_length=255, unique=True)),
                ('flavour', models.TextField(blank=True, help_text='Separate flavour text for the puzzle. Should not be required for solving the puzzle', verbose_name='Flavour text')),
                ('runtime', enumfields.fields.EnumField(default='S', enum=hunts.runtimes.Runtime, help_text='Renderer for generating the main puzzle page', max_length=1, verbose_name='Puzzle page renderer')),
                ('options', models.JSONField(blank=True, default=dict, help_text='Options for configuring the puzzle page renderer in JSON format. Currently no options are supported.', verbose_name='Puzzle page renderer configuration')),
                ('content', models.TextField(help_text='Main puzzle page content, generated using the puzzle renderer', verbose_name='Puzzle page content')),
                ('cb_runtime', enumfields.fields.EnumField(default='S', enum=hunts.runtimes.Runtime, help_text='Processor used to execute the callback script in response to AJAX requests', max_length=1, verbose_name='AJAX callback processor')),
                ('cb_options', models.JSONField(blank=True, default=dict, help_text='Options for configuring the AJAX callback processor in JSON format. Currently no options are supported.', verbose_name='AJAX callback processor configuration')),
                ('cb_content', models.TextField(blank=True, default='', help_text='Script for generating AJAX responses for callbacks made by puzzle', verbose_name='AJAX callback script')),
                ('start_date', models.DateTimeField(blank=True, help_text='Date/Time for puzzle to start. If left blank, it will start at the same time as the episode. Otherwise, this time must be after that of the episode, and must be passed for the puzzle to be available, after taking the headstart applying to the episode into account.', null=True)),
                ('headstart_granted', models.DurationField(default=datetime.timedelta(0), help_text='How much headstart this puzzle gives to later episodes which gain headstart from this episode')),
                ('soln_content', models.TextField(blank=True, default='', help_text='Content to be displayed to all users on the puzzle page after the event has completed', verbose_name='Solution content')),
                ('soln_options', models.JSONField(blank=True, default=dict, help_text='Options for configuring the solution renderer in JSON format. Currently no options are supported.', verbose_name='Solution renderer configuration')),
                ('soln_runtime', enumfields.fields.EnumField(default='S', enum=hunts.runtimes.Runtime, help_text='Renderer for generating the question solution', max_length=1, verbose_name='Solution renderer')),
                ('url_id', models.CharField(default=hunts.models.generate_url_id, editable=False, max_length=8, unique=True)),
            ],
            options={
                'ordering': ('episode', 'start_date', 'order')
            },
        ),
        migrations.CreateModel(
            name='Unlock',
            fields=[
                ('text', models.TextField(blank=True, help_text='Text displayed when this clue is unlocked')),
                ('puzzle', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='hunts.puzzle')),
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
            ],
            options={
                'abstract': False,
                'unique_together': set(),
            },
        ),
        migrations.CreateModel(
            name='Answer',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('runtime', enumfields.fields.EnumField(default='S', enum=hunts.runtimes.Runtime, help_text='Processor to use to check whether guess is correct', max_length=1, verbose_name='Validator')),
                ('answer', models.TextField()),
                ('for_puzzle', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='hunts.puzzle')),
                ('options', models.JSONField(blank=True, default=dict, help_text="Options for configuring the validator in JSON format using the following keys:\n\nStatic:\n    'case_handling': [Default: lower]\n        'none' - do not adjust case\n        'lower' - compare lower case\n        'fold' - perform unicode case folding\n    'strip': true/false [Default: true]\n\nRegex:\n    'case_sensitive': true/false [Default: false]", verbose_name='Validator configuration')),
            ],
        ),
        migrations.CreateModel(
            name='Guess',
            fields=[
                ('guess', models.TextField(max_length=512)),
                ('given', models.DateTimeField(default=django.utils.timezone.now)),
                ('correct_current', models.BooleanField(default=False)),
                ('by', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('by_team', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to='teams.team')),
                ('correct_for', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to='hunts.answer')),
                ('for_puzzle', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='hunts.puzzle')),
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ('late', models.BooleanField()),
                ('sequence', models.IntegerField()),
            ],
            options={
                'verbose_name_plural': 'Guesses',
                'unique_together': {('for_puzzle', 'by', 'sequence')},
            },
        ),
        migrations.CreateModel(
            name='UnlockAnswer',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('runtime', enumfields.fields.EnumField(default='S', enum=hunts.runtimes.Runtime, help_text='Processor to use to check whether guess unlocks this unlock', max_length=1, verbose_name='Validator')),
                ('guess', models.TextField()),
                ('unlock', models.ForeignKey(editable=False, on_delete=django.db.models.deletion.CASCADE, to='hunts.unlock')),
                ('options', models.JSONField(blank=True, default=dict, help_text="Options for configuring the validator in JSON format using the following keys:\n\nStatic:\n    'case_handling': [Default: lower]\n        'none' - do not adjust case\n        'lower' - compare lower case\n        'fold' - perform unicode case folding\n    'strip': true/false [Default: true]\n\nRegex:\n    'case_sensitive': true/false [Default: false]", verbose_name='Validator configuration')),
            ],
        ),
        migrations.CreateModel(
            name='TeamPuzzleProgress',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('start_time', models.DateTimeField()),
                ('puzzle', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='hunts.puzzle')),
                ('solved_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to='hunts.guess')),
                ('late', models.BooleanField()),
                ('team', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='teams.team')),
            ],
            options={
                'unique_together': {('puzzle', 'team')},
                'verbose_name_plural': 'Team puzzle progresses',
            },
        ),
        migrations.CreateModel(
            name='TeamUnlock',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('team_puzzle_progress', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='hunts.teampuzzleprogress')),
                ('unlockanswer', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='hunts.unlockanswer')),
                ('unlocked_by', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='hunts.guess')),
            ],
            options={
                'abstract': False,
                'unique_together': {('team_puzzle_progress', 'unlockanswer', 'unlocked_by')},
            },
        ),
        migrations.AddField(
            model_name='teampuzzleprogress',
            name='unlockanswers',
            field=models.ManyToManyField(through='hunts.TeamUnlock', to='hunts.UnlockAnswer'),
        ),
        migrations.CreateModel(
            name='EpisodePrequel',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('child', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='parent_edges', to='hunts.episode')),
                ('parent', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='children_edges', to='hunts.episode')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='episode',
            name='children',
            field=models.ManyToManyField(blank=True, related_name='parents', through='hunts.EpisodePrequel', to='hunts.Episode'),
        ),
        migrations.CreateModel(
            name='SolutionFile',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('slug', models.CharField(blank=True, help_text='Include the URL of the file in puzzle content using $slug or ${slug}.', max_length=50, null=True, verbose_name='Template Slug')),
                ('file', models.FileField(help_text='The extension of the uploaded file will determine the Content-Type of the file when served', upload_to=hunts.models.solution_file_path)),
                ('puzzle', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='hunts.puzzle')),
                ('url_path', models.CharField(help_text='The file path you want to appear in the URL. Can include "directories" using /', max_length=50, verbose_name='URL Filename')),
            ],
            options={
                'unique_together': {('puzzle', 'slug'), ('puzzle', 'url_path')},
            },
        ),
        migrations.CreateModel(
            name='Headstart',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('headstart_adjustment', models.DurationField(default=datetime.timedelta(0), help_text='Time difference to apply to the headstart for the team on the specified episode. This will apply in addition to any headstart they earn through other mechanisms.')),
                ('episode', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='hunts.episode')),
                ('team', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='teams.team')),
            ],
            options={
                'unique_together': {('episode', 'team')},
                'ordering': ('episode', 'headstart_adjustment'),
            },
        ),
        migrations.CreateModel(
            name='TeamData',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('data', models.JSONField(blank=True, null=True)),
                ('team', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to='teams.team')),
            ],
            options={
                'verbose_name_plural': 'Team data',
            },
        ),
        migrations.CreateModel(
            name='UserData',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('data', models.JSONField(blank=True, null=True)),
                ('event', models.ForeignKey(on_delete=django.db.models.deletion.DO_NOTHING, to='events.event')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'User data',
                'unique_together': {('event', 'user')},
            },
        ),
        migrations.CreateModel(
            name='UserPuzzleData',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('token', models.UUIDField(default=uuid.uuid4, editable=False)),
                ('data', models.JSONField(blank=True, null=True)),
                ('puzzle', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='hunts.puzzle')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'User puzzle data',
                'unique_together': {('puzzle', 'user')},
            },
        ),
        migrations.CreateModel(
            name='Announcement',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(max_length=255)),
                ('posted', models.DateTimeField(default=django.utils.timezone.now)),
                ('message', models.TextField(blank=True)),
                ('type', enumfields.fields.EnumField(default='I', enum=hunts.models.AnnouncementType, max_length=1)),
                ('puzzle', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='announcements', to='hunts.puzzle')),
                ('notify', enumfields.fields.EnumField(default='N', enum=hunts.models.AnnouncementNotificationOption, max_length=1)),
            ],
        ),
        migrations.CreateModel(
            name='Hint',
            fields=[
                ('text', models.TextField(help_text='Text displayed when this clue is unlocked')),
                ('time', models.DurationField(help_text='Time after anyone on the team first loads the puzzle or (if set) unlocks the related unlock to display this hint', validators=[django.core.validators.MinValueValidator(datetime.timedelta(0))], verbose_name='Delay')),
                ('puzzle', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='hunts.puzzle')),
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ('start_after', models.ForeignKey(blank=True, help_text='If you select an unlock here, the time will start counting from when that is unlocked.', null=True, on_delete=django.db.models.deletion.CASCADE, to='hunts.unlock', verbose_name='Start after Unlock')),
                ('obsoleted_by', models.ManyToManyField(blank=True, help_text='Any unlock added here will, when unlocked, cause this hint to be immediately revealed.', related_name='obsoletes', to='hunts.Unlock', verbose_name='Reveal after Unlock')),
            ],
            options={
                'abstract': False,
                'unique_together': set(),
            },
        ),
        migrations.CreateModel(
            name='HintAcceptance',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('accepted_at', models.DateTimeField(default=django.utils.timezone.now)),
                ('hint', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='hunts.hint')),
                ('team_puzzle_progress', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='hint_acceptances', to='hunts.teampuzzleprogress')),
            ],
            options={
                'unique_together': {('team_puzzle_progress', 'hint')},
            },
        ),
        migrations.AddField(
            model_name='teampuzzleprogress',
            name='accepted_hints',
            field=models.ManyToManyField(through='hunts.HintAcceptance', to='hunts.Hint'),
        ),
        migrations.CreateModel(
            name='TeamPuzzleData',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('data', models.JSONField(blank=True, null=True)),
                ('puzzle', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='hunts.puzzle')),
                ('team', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='teams.team')),
            ],
            options={
                'verbose_name_plural': 'Team puzzle data',
                'unique_together': {('puzzle', 'team')},
            },
        ),
        migrations.CreateModel(
            name='PuzzleFile',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('slug', models.CharField(blank=True, help_text='Include the URL of the file in puzzle content using $slug or ${slug}.', max_length=50, null=True, verbose_name='Template Slug')),
                ('file', models.FileField(help_text='The extension of the uploaded file will determine the Content-Type of the file when served', upload_to=hunts.models.puzzle_file_path)),
                ('puzzle', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='hunts.puzzle')),
                ('url_path', models.CharField(help_text='The file path you want to appear in the URL. Can include "directories" using /', max_length=50, verbose_name='URL Filename')),
            ],
            options={
                'unique_together': {('puzzle', 'slug'), ('puzzle', 'url_path')},
            },
        ),
    ]
